@use "../../styles/colors";
@use "../../styles/defaults";

$left-spacing: 1rem;

.overlay {
  visibility: hidden;
  opacity: 0;
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  height: 100vh;
  background-color: colors.$overlay-transparent;
  cursor: pointer;
  z-index: 1;
  transition: visibility 0.2s, opacity 0.2s;

  &--opened {
    visibility: visible;
    opacity: 1;
  }
}

.container {
  visibility: hidden;
  position: fixed;
  top: 0;
  left: 5%;
  bottom: 0;
  z-index: 2;
  width: 60%;
  background-color: colors.$primary-dark;
  padding: 5.4rem;
  border-top-right-radius: defaults.$large-border-radius;
  border-bottom-right-radius: defaults.$large-border-radius;

  &--opened {
    visibility: visible;
    animation: slideRight 0.6s;
  }

  &--closed {
    visibility: hidden;
    animation: slideLeft 0.4s;
  }

  &__title {
    text-transform: capitalize;
    font-weight: 700;
    font-size: 2.4rem;
    line-height: 2.6rem;
    margin-bottom: 4.8rem;
    margin-left: $left-spacing;
  }

  &__form {
    height: 100%;

    &.ng-submitted &__content {
      &__section {
        &__field {
          &__input {
            &.ng-invalid {
              border: 1px solid colors.$primary-warn;
            }
          }
        }
      }
    }

    &__content {
      height: 85%;
      margin-bottom: 3.2rem;
      padding: 0 3.2rem 0 $left-spacing;
      overflow-y: auto;

      &::-webkit-scrollbar {
        width: 1.6rem;
      }

      &::-webkit-scrollbar-track {
        background-color: colors.$primary-accent;
        border-radius: 1rem;
      }

      &::-webkit-scrollbar-thumb {
        background-color: colors.$primary;
        border-radius: 1rem;
      }

      &::-webkit-scrollbar-thumb:hover {
        background-color: colors.$primary-hover;
      }

      &__label {
        font-weight: 700;
        color: colors.$primary;
        margin-bottom: 2.4rem;
      }

      &__section {
        display: grid;
        gap: 1.6rem;
        margin-bottom: 4.8rem;

        &--by-threes {
          grid-template-columns: repeat(3, 1fr);
        }

        &--by-twos {
          grid-template-columns: repeat(2, 1fr);
        }

        &--by-fives {
          display: grid;
          grid-template-columns: 1fr 7rem 13rem max-content min-content;
          grid-auto-columns: min-content;
        }

        &__field {
          display: flex;
          flex-direction: column;
          justify-content: flex-start;
          gap: 0.6rem;

          &--error {
            color: colors.$primary-warn;
            margin: 3.2rem 0;
          }

          &--row {
            grid-column: 1 / -1;
          }

          &--between {
            justify-content: flex-start;
          }

          &__value {
            margin: auto 0;
          }

          &__input {
            border: none;
            border-radius: 0.6rem;
            background-color: colors.$secondary-accent;
            outline: none;
            padding: 1.8rem 0.8rem;
            color: colors.$light;
            font-weight: 700;
            width: 100%;
            &:focus {
              outline: 1px solid colors.$primary-hover;
            }
          }

          &__button {
            align-self: end;
            display: flex;
            align-items: center;
            justify-content: center;
            height: 5rem;
            border: none;
            background-color: transparent;
            cursor: pointer;

            &__trash {
              stroke: colors.$light;
              width: 2rem;
              height: 2rem;
              transition: stroke 0.3s;

              &:hover {
                stroke: colors.$primary-warn;
              }
            }
          }
        }
      }
    }

    &__footer {
      display: grid;
      grid-template-columns: 1fr auto auto;
      gap: 1rem;
    }
  }
}

@keyframes slideRight {
  0% {
    transform: translateX(-50rem);
    visibility: hidden;
  }
  50% {
    transform: translateX(3rem);
    visibility: visible;
  }
  100% {
    transform: translateX(1);
  }
}

@keyframes slideLeft {
  0% {
    transform: translateX(1);
    visibility: visible;
  }
  100% {
    transform: translateX(-100rem);
    visibility: hidden;
  }
}

@media (max-width: 650px) {
  .container {
    width: 100%;
    top: defaults.$sidebar-width-tablet;
    left: 0;
    padding: 3.6rem 1.8rem;
    border-radius: 0;

    &__form {
      &__content {
        &__section {
          &--by-threes {
            grid-template-columns: repeat(2, 1fr);
          }
          &--by-threes &__field {
            &:last-child {
              grid-column: 1 / -1;
            }
          }
          &--by-fives &__field {
            &:first-child {
              grid-column: 1 / -1;
            }
          }
          &--by-fives {
            grid-template-columns: 2fr 4fr 3fr auto;
          }
        }
      }
    }
  }
}
